//Leons Petrazickis
//The Big Little Ice Age Events Generator
//Uses St Leo's Civ++ Event Engine V1.0

#include<fstream.h>
#include<string.h>	//Delete this

ofstream fout("events.txt");		//creates a variable of type ofstream

//Triggers
void citytaken(char city[255],
			   char attacker[255],
			   char defender[255]);
void negotiation(char talker[255],
				 char talkertype[255],
				 char listener[255],
				 char listenertype[255]);
void randomturn(int denominator);
void scenarioloaded();
void turn(int turn);
void unitkilled(char unit[255],
				char attacker[255],
				char defender[255]);

//Actions
void changemoney(char receiver[255],
				 int amount);
void createunit(char owner[255],
				char unit[255],
				char veteran[255],
				char homecity[255],
				char loc[255]);
void destroyacivilization(char whom[255]);
void justonce();
void noschism(char defender[255]);
void playwavefile(char filename[255]);
void text(char text[32000]);

//Keywords
void beginevents();
void endevents();
void IF();
void THEN();
void ENDIF();
void debug();

//Useful Variable
char civs[4][256] = {
		"OrientEx",
		"World",
		"Germans",
		"Barbarians"};

void main(){
	//Scenario-specific variables
	char answer = ' ';			//Answer to prompts
	int x=0;					//Index for loops
	int number = 5;
	int spafreq = 3;
	char assloc[] = "70,106";

	cout << "Welcome to the Setup Program for the Big Little Ice Age.\n";
	cout << "\t-Answer in lowercase and follow up with an [Enter]\n";
	cout << "\t-Run it again whenever needed\n";
	cout << "\t-If it summons aliens from Alpha Centauri, it is not my fault\n\n";

	beginevents();
	//debug();

	IF();
	noschism("ANYBODY");
	THEN();
	ENDIF();

	IF();
	negotiation("ANYBODY","HUMANORCOMPUTER","ANYBODY","HUMANORCOMPUTER");
	THEN();
	ENDIF();

	IF();
	unitkilled("Surveyor", "ANYBODY", "ANYBODY");
	THEN();
	createunit("OrientEx", "Surveyor", "no", "NONE", "27,5");
	text("You've hired a replacement Surveyor back in Paris.");
	ENDIF();

	IF();
	citytaken("Milan", "ANYBODY", "ANYBODY");
	THEN();
	text("Your recruiters have hired some veteran strike-busters in Milan.");
	createunit("OrientEx", "Hired Goons", "Yes", "NONE", "44,8");
	ENDIF();

	IF();
	citytaken("Milan", "ANYBODY", "ANYBODY");
	THEN();
	createunit("OrientEx", "Hired Goons", "Yes", "NONE", "44,8");
	ENDIF();

	IF();
	citytaken("Milan", "ANYBODY", "ANYBODY");
	THEN();
	createunit("OrientEx", "Hired Goons", "Yes", "NONE", "44,8");
	ENDIF();

	IF();
	citytaken("Vienna", "ANYBODY", "ANYBODY");
	THEN();
	text("A Viennan company that you have bought employs several excellent engineers.");
	createunit("OrientEx", "Track Layer", "Yes", "NONE", "50,2");
	ENDIF();

	IF();
	citytaken("Vienna", "ANYBODY", "ANYBODY");
	THEN();
	createunit("OrientEx", "Track Layer", "Yes", "NONE", "50,2");
	ENDIF();

	IF();
	citytaken("Vienna", "ANYBODY", "ANYBODY");
	THEN();
	createunit("OrientEx", "Station Contractor", "Yes", "NONE", "50,2");
	ENDIF();

	IF();
	citytaken("Barcelona", "ANYBODY", "ANYBODY");
	THEN();
	text("You have lured some world class geologists from the University of Barcelona.");
	createunit("OrientEx", "Surveyor", "Yes", "NONE", "28,20");
	ENDIF();

	IF();
	citytaken("Barcelona", "ANYBODY", "ANYBODY");
	THEN();
	createunit("OrientEx", "Surveyor", "Yes", "NONE", "28,20");
	ENDIF();

	IF();
	citytaken("Barcelona", "ANYBODY", "ANYBODY");
	THEN();
	createunit("OrientEx", "Track Layer", "Yes", "NONE", "28,20");
	ENDIF();
	
	endevents();
	fout.close();
}

void changemoney(char receiver[255],
				 int amount){
	fout << "ChangeMoney\n";
	fout << "receiver=" << receiver << "\n";
	fout << "amount=" << amount << "\n";
}

void createunit(char owner[255],
				char unit[255],
				char veteran[255],
				char homecity[255],
				char loc[255]){
	fout << "CreateUnit\n";
	fout << "owner=" << owner << "\n";
	fout << "unit=" << unit << "\n";
	fout << "veteran=" << veteran << "\n";
	fout << "homecity=" << homecity << "\n";
	fout << "locations\n" << loc << "\nendlocations\n";
}

void destroyacivilization(char whom[255]){
	fout << "DestroyACivilization\n";
	fout << "whom=" << whom << "\n";
}

void unitkilled(char unit[255],
				char attacker[255],
				char defender[255]){
	fout << "UnitKilled\n";
	fout << "unit=" << unit << "\n";
	fout << "attacker=" << attacker << "\n";
	fout << "defender=" << defender << "\n";
}

void randomturn(int denominator){
	fout << "RandomTurn\n";
	fout << "denominator=" << denominator << "\n";
}

void turn(int turn){
	fout << "Turn\n";
	fout << "turn=" << turn << "\n";
}

void negotiation(char talker[255],
				 char talkertype[255],
				 char listener[255],
				 char listenertype[255]){
    fout << "Negotiation\n";
    fout << "talker=" << talker << "\n";
    fout << "talkertype="<< talkertype << "\n";
    fout << "listener="<< listener << "\n";
    fout << "listenertype="<< listenertype << "\n";
}

void text(char text[32000]){
	fout << "Text\n";
	fout << text << "\n";
	fout << "EndText\n";
}


void beginevents(){
	fout << "@BEGINEVENTS\n";
}

void endevents(){
	fout << "@ENDEVENTS\n";
}

void IF(){
	fout << "@IF\n";
}

void THEN(){
	fout << "@THEN\n";
}

void ENDIF(){
	fout << "@ENDIF\n";
}

void justonce(){
	fout << "JustOnce\n";
}

void noschism(char defender[255]){
	fout << "NoSchism\n";
	fout << "defender=" << defender << "\n";
}

void citytaken(char city[255],
			   char attacker[255],
			   char defender[255]){
	fout << "CityTaken\n";
	fout << "city=" << city << "\n";
	fout << "attacker=" << attacker << "\n";
	fout << "defender=" << defender << "\n";
}

void playwavefile(char filename[255]){
	fout << "PlayWaveFile\n";
	fout << filename << "\n";
}

void scenarioloaded(){
	fout << "ScenarioLoaded\n";
}

void debug(){
	fout << "@DEBUG\n";
}